<template>
  <g>
    <path :d="dAttr" :style="pathStyle"></path>
    <path d="M -1 -1 L 0 1 L 1 -1 z" :style="arrowStyle" :transform="arrowTransform"></path>
  </g>
</template>

<script lang="ts">
import { Point2D, RefinedLink } from 'src/models/workflow';
import { defineComponent, computed, PropType } from 'vue';

export default defineComponent({
  props: {
    link: {
      type: Object as PropType<RefinedLink>,
      default: () => {
        return <RefinedLink>{
          id: '',
          start: {
            x: 0,
            y: 0,
          },
          end: {
            x: 0,
            y: 0,
          },
        };
      },
    },
  },

  setup(props) {
    const distance = (start: Point2D, end: Point2D) => {
      return Math.sqrt(Math.pow(end.x - start.x, 2) + Math.pow(end.y - start.y, 2));
    };

    const computeConnectionPoint = (start: Point2D, end: Point2D, t: number): Point2D => {
      let dist = distance(start, end);
      let p0 = start;
      let p1 = { x: start.x + dist * 0.25, y: start.y };
      let p2 = { x: end.x - dist * 0.25, y: end.y };
      let p3 = end;
      let c1 = (1 - t) * (1 - t) * (1 - t);
      let c2 = 3 * ((1 - t) * (1 - t)) * t;
      let c3 = 3 * (1 - t) * (t * t);
      let c4 = t * t * t;
      let x = c1 * p0.x + c2 * p1.x + c3 * p2.x + c4 * p3.x;
      let y = c1 * p0.y + c2 * p1.y + c3 * p2.y + c4 * p3.y;
      return { x: x, y: y };
    };

    const pathStyle = computed(() => {
      return {
        stroke: 'rgb(64, 64, 64)',
        strokeWidth: 2.2,
        fill: 'none',
      };
    });

    const arrowStyle = computed(() => {
      return {
        stroke: 'rgb(64, 64, 64)',
        strokeWidth: 10,
        fill: 'none',
      };
    });

    const arrowTransform = computed(() => {
      let pos = computeConnectionPoint(props.link.start, props.link.end, 0.5);
      let pos2 = computeConnectionPoint(props.link.start, props.link.end, 0.51);
      let angle = -Math.atan2(pos2.x - pos.x, pos2.y - pos.y);
      let degrees = ((angle >= 0 ? angle : 2 * Math.PI + angle) * 180) / Math.PI;
      return `translate(${pos.x}, ${pos.y}) rotate(${degrees})`;
    });

    const dAttr = computed(() => {
      let start = props.link.start;
      let end = props.link.end;
      let dist = distance(start, end) * 0.25;
      return `M ${start.x}, ${start.y} C ${start.x + dist}, ${start.y}, ${end.x - dist}, ${end.y}, ${end.x}, ${end.y}`;
    });

    return {
      dAttr,
      pathStyle,
      arrowTransform,
      arrowStyle,
    };
  },
});
</script>

<style scoped lang="sass">

.side-menu
  position: absolute
  top: 0px
  left: 0px

path:hover
  stroke: '#26a9e0'
</style>
